// START SNIPPET: prolog
import uk.ac.ncl.cs.instantsoap.wsapi.*;
import static uk.ac.ncl.cs.instantsoap.wsapi.Wsapi.*;
import org.apache.cxf.jaxws.*;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import java.util.List;
import java.util.Map;

public class IntrospectingClient
{
  public static void main(String[] args)
          throws Throwable
  {
// END SNIPPET: prolog

// START SNIPPET: dispatcher-setup
    ClassPathXmlApplicationContext context
            = new ClassPathXmlApplicationContext(new String[] {"client-beans.xml"});

    WebServiceDispatcher dispatcher = (WebServiceDispatcher) context.getBean("client");
// END SNIPPET: dispatcher-setup

// START SNIPPET: fetch-applications
    System.out.println("Fetching a list of all applications");
    List<String> appNames = dispatcher.listApplications();
    System.out.println("There are " + appNames.size() + " applications loaded");
// END SNIPPET: fetch-applications

// START SNIPPET: describe-application
    for(String appName : appNames)
    {
      MetaData appMD = dispatcher.describeApplication(appName);
      System.out.println(appMD.getName() + ": " + appMD.getDescription());
// END SNIPPET: describe-application

// START SNIPPET: inputs-outputs
      System.out.println("  Inputs:");
      for(MetaData imd : dispatcher.getInputs(appName))
      {
        System.out.println("\t" + imd.getName() + ": " + imd.getDescription());
      }

      System.out.println("  Outputs:");
      for(MetaData omd : dispatcher.getOutputs(appName))
      {
        System.out.println("\t" + omd.getName() + ": " + omd.getDescription());
      }
// END SNIPPET: inputs-outputs

// START SNIPPET: epilog
      System.out.println();
    }

    System.out.println("Done!");
  }
}
// END SNIPPET: epilog